import { Action } from '@ngrx/store';
import { Comment, CommentUI } from './../models/comment';
export declare const ADD = "[comment] Add";
export declare const GET = "[comment] Get";
export declare const UPDATE = "[comment] Update";
export declare const DELETE = "[comment] Delete";
export declare const ADD_SUCCESS = "[comment] AddSuccess";
export declare const ADD_ERROR = "[comment] AddError";
export declare const GET_SUCCESS = "[comment] GetSuccess";
export declare const GET_ERROR = "[comment] GetError";
export declare const UPDATE_SUCCESS = "[comment] UpdateSuccess";
export declare const UPDATE_ERROR = "[comment] UpdateError";
export declare const DELETE_SUCCESS = "[comment] DeleteSuccess";
export declare const DELETE_ERROR = "[comment] DeleteError";
export declare class Add implements Action {
    payload: {
        url: string;
        comment: Comment;
    };
    constructor(payload: {
        url: string;
        comment: Comment;
    });
    readonly type: string;
}
export declare class Get implements Action {
    payload: string;
    constructor(payload: string);
    readonly type: string;
}
export declare class Update implements Action {
    payload: Comment;
    constructor(payload: Comment);
    readonly type: string;
}
export declare class Delete implements Action {
    payload: CommentUI;
    constructor(payload: CommentUI);
    readonly type: string;
}
export declare class AddSuccess implements Action {
    payload: CommentUI;
    constructor(payload: CommentUI);
    readonly type: string;
}
export declare class AddError implements Action {
    readonly type: string;
}
export declare class GetSuccess implements Action {
    payload: CommentUI[];
    constructor(payload: CommentUI[]);
    readonly type: string;
}
export declare class GetError implements Action {
    readonly type: string;
}
export declare class UpdateSuccess implements Action {
    payload: CommentUI;
    constructor(payload: CommentUI);
    readonly type: string;
}
export declare class UpdateError implements Action {
    readonly type: string;
}
export declare class DeleteSuccess implements Action {
    payload: CommentUI;
    constructor(payload: CommentUI);
    readonly type: string;
}
export declare class DeleteError implements Action {
    readonly type: string;
}
export declare type All = Add | Get | Update | Delete | AddSuccess | AddError | GetSuccess | GetError | UpdateSuccess | UpdateError | DeleteSuccess | DeleteError;
