import { Action } from '@ngrx/store';
import { CustomQueryModel } from './../models/custom-query.model';
export declare const ADD = "[customQuery] Add";
export declare const ADD_SUCCESS = "[customQuery] AddSuccess";
export declare const ADD_ERROR = "[customQuery] AddError";
export declare const GET = "[customQuery] Get";
export declare const GET_SUCCESS = "[customQuery] GetSuccess";
export declare const GET_ERROR = "[customQuery] GetError";
export declare const DELETE = "[customQuery] Delete";
export declare const DELETE_SUCCESS = "[customQuery] DeleteSuccess";
export declare const DELETE_ERROR = "[customQuery] DeleteError";
export declare const SELECT = "[customQuery] Select";
export declare const SELECT_NONE = "[customQuery] Select None";
export declare class Add implements Action {
    payload: CustomQueryModel;
    constructor(payload: CustomQueryModel);
    readonly type: string;
}
export declare class AddSuccess implements Action {
    payload: CustomQueryModel;
    constructor(payload: CustomQueryModel);
    readonly type: string;
}
export declare class AddError implements Action {
    readonly type: string;
}
export declare class Get implements Action {
    readonly type: string;
}
export declare class GetSuccess implements Action {
    payload: CustomQueryModel[];
    constructor(payload: CustomQueryModel[]);
    readonly type: string;
}
export declare class GetError implements Action {
    readonly type: string;
}
export declare class Delete implements Action {
    payload: CustomQueryModel;
    constructor(payload: CustomQueryModel);
    readonly type: string;
}
export declare class DeleteSuccess implements Action {
    payload: CustomQueryModel;
    constructor(payload: CustomQueryModel);
    readonly type: string;
}
export declare class DeleteError implements Action {
    readonly type: string;
}
export declare class Select implements Action {
    payload: CustomQueryModel;
    constructor(payload: CustomQueryModel);
    readonly type: string;
}
export declare class SelectNone implements Action {
    readonly type: string;
}
export declare type All = Get | GetSuccess | GetError | AddSuccess | AddError | DeleteSuccess | DeleteError | Select | SelectNone;
