import { Action } from '@ngrx/store';
import { WorkItemLinkService, WorkItemLinkUI } from './../models/link';
export declare const ADD = "[workItemLink] Add";
export declare const GET = "[workItemLink] Get";
export declare const DELETE = "[workItemLink] Delete";
export declare const ADD_SUCCESS = "[workItemLink] AddSuccess";
export declare const GET_SUCCESS = "[workItemLink] GetSuccess";
export declare const DELETE_SUCCESS = "[workItemLink] DeleteSuccess";
export declare const ADD_ERROR = "[workItemLink] AddError";
export declare const GET_ERROR = "[workItemLink] GetError";
export declare const DELETE_ERROR = "[workItemLink] DeleteError";
export declare const RESET_LINKS = "[workItemLink] Reset";
export declare const TRIVIALIZE_ALL = "[workItemLink] TrivializeAll";
export declare class Add implements Action {
    payload: WorkItemLinkService;
    constructor(payload: WorkItemLinkService);
    readonly type: string;
}
export declare class Get implements Action {
    payload: string;
    constructor(payload: string);
    readonly type: string;
}
export declare class Delete implements Action {
    payload: {
        wiLink: WorkItemLinkUI;
        workItemId: string;
    };
    constructor(payload: {
        wiLink: WorkItemLinkUI;
        workItemId: string;
    });
    readonly type: string;
}
export declare class AddSuccess implements Action {
    payload: WorkItemLinkUI;
    constructor(payload: WorkItemLinkUI);
    readonly type: string;
}
export declare class GetSuccess implements Action {
    payload: WorkItemLinkUI[];
    constructor(payload: WorkItemLinkUI[]);
    readonly type: string;
}
export declare class DeleteSuccess implements Action {
    payload: WorkItemLinkUI;
    constructor(payload: WorkItemLinkUI);
    readonly type: string;
}
export declare class AddError implements Action {
    readonly type: string;
}
export declare class GetError implements Action {
    readonly type: string;
}
export declare class DeleteError implements Action {
    readonly type: string;
}
export declare class ResetLinks implements Action {
    readonly type: string;
}
export declare class TrivializeAll implements Action {
    readonly type: string;
}
export declare type All = Add | AddSuccess | AddError | Get | GetSuccess | GetError | Delete | DeleteSuccess | DeleteError | ResetLinks | TrivializeAll;
