import { Action } from '@ngrx/store';
import { IterationUI } from '../models/iteration.model';
import { WorkItemService, WorkItemUI } from './../models/work-item';
export declare const ADD = "[workItem] Add";
export declare const GET = "[workItem] Get";
export declare const UPDATE = "[workItem] Update";
export declare const ADD_SUCCESS = "[workItem] AddSuccess";
export declare const ADD_ERROR = "[workItem] AddError";
export declare const GET_SUCCESS = "[workItem] GetSuccess";
export declare const GET_ERROR = "[workItem] GetError";
export declare const UPDATE_SUCCESS = "[workItem] UpdateSuccess";
export declare const UPDATE_ERROR = "[workItem] UpdateError";
export declare const GET_CHILDREN = "[workItem] GetChildren";
export declare const GET_CHILDREN_SUCCESS = "[workItem] GetChildrenSuccess";
export declare const GET_CHILDREN_ERROR = "[workItem] GetChildrenError";
export declare const REORDER = "[workItem] Reorder";
export declare const REORDER_ERROR = "[workItem] ReorderError";
export declare const UPDATE_WORKITEM_ITERATION = "[workItem] UpdateWorkitemIteration";
export declare const CREATE_LINK = "[workItemLink] CreateLink";
export declare const DELETE_LINK = "[workItemLink] DeleteLink";
export declare const RESET_WORKITEMS = "[workItem] Reset WorkItems";
export declare const GET_MORE_WORKITEMS = "[workItems] Get More WorkItems";
export declare const GET_MORE_WORKITEMS_SUCCESS = "[workItems] Get More WorkItems Success";
export declare const NEXT_LINK_SUCCESS = "[workItem] Next Link Success";
export declare const DELETE = "[workItem] Delete";
export declare const DELETE_SUCCESS = "[workItem] DeleteSuccess";
export declare const DELETE_ERROR = "[workItem] DeleteError";
export declare class Add implements Action {
    payload: {
        workItem: WorkItemService;
        createId: number;
        parentId: string;
        openDetailPage: boolean;
    };
    constructor(payload: {
        workItem: WorkItemService;
        createId: number;
        parentId: string;
        openDetailPage: boolean;
    });
    readonly type: string;
}
export declare class Get implements Action {
    payload: {
        pageSize: number;
        filters: any[];
        isShowTree: boolean;
    };
    constructor(payload: any);
    readonly type: string;
}
export declare class Update implements Action {
    payload: WorkItemUI;
    constructor(payload: WorkItemUI);
    readonly type: string;
}
export declare class AddSuccess implements Action {
    payload: WorkItemUI;
    constructor(payload: WorkItemUI);
    readonly type: string;
}
export declare class AddError implements Action {
    readonly type: string;
}
export declare class GetSuccess implements Action {
    payload: {
        workItems: WorkItemUI[];
        nextLink: string;
    };
    constructor(payload: {
        workItems: WorkItemUI[];
        nextLink: string;
    });
    readonly type: string;
}
export declare class GetError implements Action {
    readonly type: string;
}
export declare class GetChildren implements Action {
    payload: WorkItemUI;
    constructor(payload: any);
    readonly type: string;
}
export declare class GetChildrenSuccess implements Action {
    payload: {
        parent: WorkItemUI;
        children: WorkItemUI[];
    };
    constructor(payload: any);
    readonly type: string;
}
export declare class GetChildrenError implements Action {
    payload: WorkItemUI;
    constructor(payload: WorkItemUI);
    readonly type: string;
}
export declare class UpdateSuccess implements Action {
    payload: WorkItemUI;
    constructor(payload: WorkItemUI);
    readonly type: string;
}
export declare class UpdateError implements Action {
    readonly type: string;
}
export declare class Reorder implements Action {
    readonly type: string;
    payload: {
        workitem: WorkItemUI;
        destinationWorkitemID: string;
        direction: string;
    };
    constructor(payload: {
        workitem: WorkItemUI;
        destinationWorkitemID: string;
        direction: string;
    });
}
export declare class UpdateWorkitemIteration implements Action {
    readonly type: string;
    payload: {
        iteration: IterationUI;
    };
    constructor(payload: {
        iteration: IterationUI;
    });
}
export declare class CreateLink implements Action {
    payload: {
        source: WorkItemUI;
        target: WorkItemUI;
        sourceTreeStatus: string;
    };
    constructor(payload: {
        source: WorkItemUI;
        target: WorkItemUI;
        sourceTreeStatus: string;
    });
    readonly type: string;
}
export declare class DeleteLink implements Action {
    payload: {
        source: WorkItemUI;
        target: WorkItemUI;
        sourceTreeStatus: string;
    };
    constructor(payload: {
        source: WorkItemUI;
        target: WorkItemUI;
        sourceTreeStatus: string;
    });
    readonly type: string;
}
export declare class ResetWorkItems implements Action {
    readonly type: string;
}
export declare class GetMoreWorkItems implements Action {
    payload: {
        isShowTree: boolean;
    };
    constructor(payload: {
        isShowTree: boolean;
    });
    readonly type: string;
}
export declare class GetMoreWorkItemsSuccess implements Action {
    payload: {
        workItems: WorkItemUI[];
        nextLink: string;
    };
    constructor(payload: {
        workItems: WorkItemUI[];
        nextLink: string;
    });
    readonly type: string;
}
export declare class Delete implements Action {
    payload: WorkItemUI;
    constructor(payload: WorkItemUI);
    readonly type: string;
}
export declare class DeleteSuccess implements Action {
    payload: WorkItemUI;
    constructor(payload: WorkItemUI);
    readonly type: string;
}
export declare class DeleteError implements Action {
    readonly type: string;
}
export declare type All = Add | Get | Update | AddSuccess | AddError | GetSuccess | GetError | UpdateSuccess | UpdateError | GetChildren | GetChildrenSuccess | GetChildrenError | Reorder | UpdateWorkitemIteration | CreateLink | DeleteLink | ResetWorkItems | GetMoreWorkItems | GetMoreWorkItemsSuccess | Delete | DeleteSuccess | DeleteError;
