import { OnDestroy, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Spaces } from 'ngx-fabric8-wit';
import { AuthenticationService } from 'ngx-login-client';
import { FilterService } from '../../services/filter.service';
import { ModalService } from '../../services/modal.service';
import { Store } from '@ngrx/store';
import { AppState } from './../../states/app.state';
export declare class CustomQueryComponent implements OnInit, OnDestroy {
    private auth;
    private filterService;
    private modalService;
    private route;
    private spaces;
    private store;
    sidePanelOpen: boolean;
    context: 'list' | 'board';
    authUser: any;
    private spaceId;
    private eventListeners;
    private customQueries;
    private startedCheckingURL;
    private showTree;
    private showCompleted;
    constructor(auth: AuthenticationService, filterService: FilterService, modalService: ModalService, route: ActivatedRoute, spaces: Spaces, store: Store<AppState>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    constructUrl(attributes: any): string;
    checkURL(): void;
    addRemoveQueryParams(queryField: any): {
        q: string;
        showTree: string;
        showCompleted: string;
    } | {
        q: string;
        showTree: string;
        showCompleted?: undefined;
    } | {
        q: string;
        showCompleted: string;
        showTree?: undefined;
    } | {
        q: string;
        showTree?: undefined;
        showCompleted?: undefined;
    };
    getRouterLink(): string[];
    stopPropagation(event: any): void;
    confirmCustomQueryDelete(event: any, customQuery: any): void;
    deleteCustomQuery(customQuery: any): void;
}
