import { OnDestroy, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Spaces } from 'ngx-fabric8-wit';
import { AuthenticationService } from 'ngx-login-client';
import { GroupTypeQuery, GroupTypeUI } from '../../models/group-types.model';
import { FilterService } from '../../services/filter.service';
import { Store } from '@ngrx/store';
import { SpaceQuery } from '../../models/space';
import { AppState } from './../../states/app.state';
export declare class GroupTypesComponent implements OnInit, OnDestroy {
    private auth;
    private filterService;
    private groupTypeQuery;
    private spaceQuery;
    private route;
    private router;
    private spaces;
    private store;
    sidePanelOpen: boolean;
    context: 'list' | 'board';
    authUser: any;
    infotipSource: import("rxjs/internal/Observable").Observable<any>;
    private groupTypes;
    private eventListeners;
    private startedCheckingURL;
    private showTree;
    private showCompleted;
    constructor(auth: AuthenticationService, filterService: FilterService, groupTypeQuery: GroupTypeQuery, spaceQuery: SpaceQuery, route: ActivatedRoute, router: Router, spaces: Spaces, store: Store<AppState>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    fnBuildQueryParam(witGroup: any): string;
    fnBuildQueryParamForBoard(witGroup: any): string;
    addRemoveQueryParams(witGroup: any): {
        q: string;
        showTree?: undefined;
        showCompleted?: undefined;
    } | {
        q: string;
        showTree: string;
        showCompleted: string;
    } | {
        q: string;
        showTree: string;
        showCompleted?: undefined;
    } | {
        q: string;
        showCompleted: string;
        showTree?: undefined;
    };
    checkURL(): void;
    getInfotipText(id: string): import("rxjs/internal/Observable").Observable<any>;
    groupTypeClickHandler(e: MouseEvent, item: GroupTypeUI): void;
}
