import { EventEmitter, OnInit } from '@angular/core';
import { Observable } from 'rxjs';
import { SelectDropdownComponent } from './../../widgets/select-dropdown/select-dropdown.component';
export declare type TypeaheadDropdownItem = {
    key: string;
    value: string;
    selected: boolean;
};
export declare type TypeaheadDatasourceFunction = (string: any) => Observable<TypeaheadDropdownItem[]>;
export declare class TypeaheadSelectorComponent implements OnInit {
    dropdownRef: SelectDropdownComponent;
    dataSource: TypeaheadDatasourceFunction;
    headerText: string;
    noValueLabel: string;
    allowUpdate: boolean;
    allowMultiSelect: boolean;
    closeOnSelect: boolean;
    selectedItemsSetter: TypeaheadDropdownItem[];
    itemTruncate: number;
    toggleTruncate: number;
    readonly onSelectItem: EventEmitter<any[]>;
    readonly onOpenSelector: EventEmitter<any>;
    readonly onCloseSelector: EventEmitter<any[]>;
    private searchTermObs;
    private selectedItemsBs;
    private selectedItemsObs;
    private _selectedItems;
    selectedItems: TypeaheadDropdownItem[];
    private searchValue;
    searching: boolean;
    isOpen: boolean;
    menuItems: Observable<TypeaheadDropdownItem[]>;
    ngOnInit(): void;
    updateSelection(items: TypeaheadDropdownItem[], selectedItems: TypeaheadDropdownItem[]): TypeaheadDropdownItem[];
    onSelect(event: TypeaheadDropdownItem): void;
    onSearch(event: string): void;
    onOpen(event: any): void;
    onClose(event: any): void;
}
