import { Component, EventEmitter, Input, Output, ViewEncapsulation } from '@angular/core';
var WorkItemCellComponent = /** @class */ (function () {
    function WorkItemCellComponent() {
        this.context = 'list';
        this.onDetailPreview = new EventEmitter();
        this.onQuickPreview = new EventEmitter();
        this.clickLabel = new EventEmitter();
        this.onChildExploration = new EventEmitter();
        this.onDelete = new EventEmitter();
    }
    WorkItemCellComponent.prototype.onDetail = function (Event, id) {
        this.onDetailPreview.emit(id);
    };
    WorkItemCellComponent.prototype.labelClick = function (event) {
        this.clickLabel.emit(event);
    };
    WorkItemCellComponent.prototype.onPreview = function (Event, workItem) {
        this.onQuickPreview.emit(workItem);
    };
    WorkItemCellComponent.prototype.onExploration = function (workItem) {
        if (workItem.hasChildren) {
            this.onChildExploration.emit(workItem);
        }
    };
    WorkItemCellComponent.decorators = [
        { type: Component, args: [{
                    encapsulation: ViewEncapsulation.None,
                    selector: 'work-item-cell',
                    template: require('./work-item-cell.component.html'),
                    styles: [require('./work-item-cell.component.css').toString()]
                },] },
    ];
    /** @nocollapse */
    WorkItemCellComponent.ctorParameters = function () { return []; };
    WorkItemCellComponent.propDecorators = {
        'col': [{ type: Input },],
        'row': [{ type: Input },],
        'context': [{ type: Input },],
        'onDetailPreview': [{ type: Output },],
        'onQuickPreview': [{ type: Output },],
        'clickLabel': [{ type: Output },],
        'onChildExploration': [{ type: Output },],
        'onDelete': [{ type: Output },],
    };
    return WorkItemCellComponent;
}());
export { WorkItemCellComponent };
//# sourceMappingURL=work-item-cell.component.js.map