import { AfterViewInit, EventEmitter, OnInit } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { User } from 'ngx-login-client';
import { CommentUI } from '../../models/comment';
import { ModalService } from '../../services/modal.service';
import { WorkItemService } from './../../services/work-item.service';
export declare class WorkItemCommentComponent implements OnInit, AfterViewInit {
    private workItemService;
    private modalService;
    private sanitizer;
    loadingComments: boolean;
    comments: CommentUI[];
    loggedIn: Boolean;
    loggedInUser: User;
    readonly create: EventEmitter<CommentUI>;
    readonly update: EventEmitter<CommentUI>;
    readonly delete: EventEmitter<CommentUI>;
    isCollapsedComments: Boolean;
    commentEditable: Boolean;
    selectedCommentId: String;
    constructor(workItemService: WorkItemService, modalService: ModalService, sanitizer: DomSanitizer);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    openComment(id: any): void;
    createComment(event: any): void;
    createChildComment(newComment: CommentUI): void;
    showPreview(event: any): void;
    updateComment(comment: CommentUI): void;
    onCommentEdit($event: any, inpId: any, saveBtnId: any): void;
    closeCommentEditing(): void;
    resetCommentDraft(event?: any): void;
    preventDef(event: any): void;
}
