var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { Actions, Effect } from '@ngrx/effects';
import { Observable, of as ObservableOf } from 'rxjs';
import { catchError, map, switchMap } from 'rxjs/operators';
import { SpaceQuery } from '../models/space';
import * as LabelActions from './../actions/label.actions';
import { LabelMapper } from './../models/label.model';
import { LabelService } from './../services/label.service';
import { ErrorHandler, filterTypeWithSpace } from './work-item-utils';
var LabelEffects = /** @class */ (function () {
    function LabelEffects(actions$, labelService, spaceQuery, errHandler) {
        var _this = this;
        this.actions$ = actions$;
        this.labelService = labelService;
        this.spaceQuery = spaceQuery;
        this.errHandler = errHandler;
        this.getLabels$ = this.actions$
            .pipe(filterTypeWithSpace(LabelActions.GET, this.spaceQuery.getCurrentSpace), switchMap(function (_a) {
            var action = _a[0], space = _a[1];
            return _this.labelService.getLabels(space.links.self + '/labels')
                .pipe(map(function (labels) {
                var lMapper = new LabelMapper();
                return labels.map(function (l) { return lMapper.toUIModel(l); });
            }), map(function (labels) { return new LabelActions.GetSuccess(labels); }), catchError(function (err) { return ObservableOf(new LabelActions.GetError()); }));
        }));
        this.createLabel$ = this.actions$
            .pipe(filterTypeWithSpace(LabelActions.ADD, this.spaceQuery.getCurrentSpace), switchMap(function (_a) {
            var action = _a[0], space = _a[1];
            return _this.labelService.createLabel(action.payload, space.links.self + '/labels')
                .pipe(map(function (label) {
                var lMapper = new LabelMapper();
                var labelUI = lMapper.toUIModel(label);
                return new LabelActions.AddSuccess(labelUI);
            }), catchError(function (err) { return _this.errHandler.handleError(err, "There was some problem in adding the label.", new LabelActions.AddError()); }));
        }));
    }
    LabelEffects.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    LabelEffects.ctorParameters = function () { return [
        { type: Actions, },
        { type: LabelService, },
        { type: SpaceQuery, },
        { type: ErrorHandler, },
    ]; };
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], LabelEffects.prototype, "getLabels$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], LabelEffects.prototype, "createLabel$", void 0);
    return LabelEffects;
}());
export { LabelEffects };
//# sourceMappingURL=label.effects.js.map