import { Action } from '@ngrx/store';
import { Notifications } from 'ngx-base';
import { Observable } from 'rxjs';
import { WorkItemUI } from '../models/work-item';
import { FilterService } from '../services/filter.service';
import { WorkItemService } from '../services/work-item.service';
export declare const filterTypeWithSpace: (x: string, y: any) => import("rxjs/internal/types").UnaryFunction<Observable<Action>, Observable<{}>>;
export declare class ErrorHandler {
    private notifications;
    constructor(notifications: Notifications);
    handleError<T>(error: any, msg: string, nextActions: T | T[]): T[];
    private notifyError;
}
export declare function workitemMatchesFilter(route: any, filterService: FilterService, workItemService: WorkItemService, workitem: WorkItemUI, spaceId: string): Observable<WorkItemUI>;
export declare function createLinkObject(parentWorkItemId: string, childWorkItemId: string, linkId: string): {
    'type': string;
    'attributes': {
        'version': number;
    };
    'relationships': {
        'link_type': {
            'data': {
                'id': string;
                'type': string;
            };
        };
        'source': {
            'data': {
                'id': string;
                'type': string;
            };
        };
        'target': {
            'data': {
                'id': string;
                'type': string;
            };
        };
    };
};
