import { Store } from '@ngrx/store';
import { Observable } from 'rxjs';
import { AppState } from './../states/app.state';
export declare class LinkType {
    id: string;
    type: string;
    attributes: {
        'description': string;
        'forward_name': string;
        'name': string;
        'reverse_name': string;
        'topology': string;
        'version': number;
    };
    relationships: {
        'link_category': {
            'data': {
                'id': string;
                'type': string;
            };
        };
    };
}
export interface LinkTypeService extends LinkType {
}
export interface LinkTypeUI {
    id: string;
    name: string;
    linkType: string;
    description: string;
}
export declare class WorkItemLinkTypeQuery {
    private store;
    constructor(store: Store<AppState>);
    readonly getLinkTypes: Observable<LinkTypeUI[]>;
    readonly getLinkTypesForDropdown: Observable<{
        value: string;
        key: string;
        id: string;
        name: string;
        linkType: string;
        description: string;
    }[]>;
}
