var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { Pipe } from '@angular/core';
// tslint:disable-next-line:use-pipe-transform-interface
var WorkItemLinkFilterByTypeName = /** @class */ (function () {
    function WorkItemLinkFilterByTypeName() {
    }
    WorkItemLinkFilterByTypeName.prototype.transform = function (selectedLinkType, arr) {
        if (selectedLinkType !== null && selectedLinkType !== 'all') {
            var outputArr = arr.filter(function (item) { return item.linkName === selectedLinkType; });
            return outputArr;
        }
        return arr;
    };
    WorkItemLinkFilterByTypeName.decorators = [
        { type: Pipe, args: [{ name: 'workItemLinkFilterByTypeName', pure: true },] },
    ];
    /** @nocollapse */
    WorkItemLinkFilterByTypeName.ctorParameters = function () { return []; };
    return WorkItemLinkFilterByTypeName;
}());
export { WorkItemLinkFilterByTypeName };
var GroupWorkItemLinks = /** @class */ (function () {
    function GroupWorkItemLinks() {
    }
    GroupWorkItemLinks.prototype.transform = function (arr, workItemId) {
        /**
         * [{
         *     linkType:
         *     linkDirection:
         *     workItems: workitem[]
         * }]
         *
         */
        var linkTypes = arr.reduce(function (ltypes, curr_val) {
            if (ltypes.findIndex(function (ltype) { return curr_val.linkType.id === ltype.id; }) === -1) {
                return ltypes.concat([curr_val.linkType]);
            }
            else {
                return ltypes.slice();
            }
        }, []);
        var op = [];
        linkTypes.forEach(function (linkType) {
            var linksOfLinkType = arr.filter(function (link) {
                return link.linkType.id === linkType.id;
            });
            var forward = [];
            var reverse = [];
            var forwardLinks = [];
            var reverseLinks = [];
            linksOfLinkType.forEach(function (link) {
                if (link.source.id === workItemId) {
                    forward.push(__assign({}, link.target, { newlyAdded: link.newlyAdded }));
                    forwardLinks.push(link);
                }
                if (link.target.id === workItemId) {
                    reverse.push(__assign({}, link.source, { newlyAdded: link.newlyAdded }));
                    reverseLinks.push(link);
                }
            });
            if (forward.length) {
                op.push({
                    linkType: linkType,
                    linkDirection: 'forwardName',
                    workItems: forward,
                    links: forwardLinks
                });
            }
            if (reverse.length) {
                op.push({
                    linkType: linkType,
                    linkDirection: 'reverseName',
                    workItems: reverse,
                    links: reverseLinks
                });
            }
        });
        return op;
    };
    GroupWorkItemLinks.decorators = [
        { type: Pipe, args: [{ name: 'groupWorkItemLinks', pure: true },] },
    ];
    /** @nocollapse */
    GroupWorkItemLinks.ctorParameters = function () { return []; };
    return GroupWorkItemLinks;
}());
export { GroupWorkItemLinks };
// tslint:disable-next-line:use-pipe-transform-interface
var WorkItemLinkTypeFilterByTypeName = /** @class */ (function () {
    function WorkItemLinkTypeFilterByTypeName() {
    }
    WorkItemLinkTypeFilterByTypeName.prototype.transform = function (selectedLinkType, arr) {
        if (selectedLinkType !== 'all') {
            var outputArr = arr.filter(function (item) { return item.name === selectedLinkType; });
            return outputArr;
        }
        return arr;
    };
    WorkItemLinkTypeFilterByTypeName.decorators = [
        { type: Pipe, args: [{ name: 'workItemLinkTypeFilterByTypeName', pure: true },] },
    ];
    /** @nocollapse */
    WorkItemLinkTypeFilterByTypeName.ctorParameters = function () { return []; };
    return WorkItemLinkTypeFilterByTypeName;
}());
export { WorkItemLinkTypeFilterByTypeName };
//# sourceMappingURL=work-item-link-filters.pipe.js.map