var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as WorkItemActions from '../actions/work-item.actions';
import { InitialColumnWorkItemState } from '../states/index.state';
import * as ColumnWorkItemActions from './../actions/column-workitem.action';
export var ColumnWorkItemReducer = function (state, action) {
    if (state === void 0) { state = InitialColumnWorkItemState; }
    switch (action.type) {
        case WorkItemActions.GET_SUCCESS: {
            var cwState_1 = {};
            action.payload.workItems.forEach(function (item) {
                if (item.columnIds !== null) {
                    item.columnIds.forEach(function (col) {
                        if (cwState_1.hasOwnProperty(col)) {
                            cwState_1[col] = cwState_1[col].concat([item.id]);
                        }
                        else {
                            cwState_1[col] = [item.id];
                        }
                    });
                }
            });
            return __assign({}, cwState_1);
        }
        case ColumnWorkItemActions.UPDATE_SUCCESS: {
            var cwState_2 = __assign({}, state);
            cwState_2[action.payload.prevColumnId] =
                cwState_2[action.payload.prevColumnId]
                    .filter(function (id) { return id !== action.payload.workItemId; });
            action.payload.newColumnIds.forEach(function (col) {
                if (cwState_2.hasOwnProperty(col)) {
                    cwState_2[col] = cwState_2[col].concat([action.payload.workItemId]);
                }
                else {
                    cwState_2[col] = [action.payload.workItemId];
                }
            });
            return __assign({}, cwState_2);
        }
        case ColumnWorkItemActions.UPDATE_ERROR: {
            var newState_1 = __assign({}, state);
            newState_1[action.payload.prevColumnId] = state[action.payload.prevColumnId].slice();
            action.payload.newColumnIds.forEach(function (colId) {
                newState_1[colId] = state[colId].slice();
            });
            return __assign({}, newState_1);
        }
        default: {
            return state;
        }
    }
};
//# sourceMappingURL=column-workitem.reducer.js.map