import { Observable } from 'rxjs';
import { Logger } from 'ngx-base';
import { Spaces } from 'ngx-fabric8-wit';
import { AreaModel } from '../models/area.model';
import { HttpClientService } from '../shared/http-module/http.service';
export declare class AreaService {
    private logger;
    private http;
    private spaces;
    areas: AreaModel[];
    private _currentSpace;
    constructor(logger: Logger, http: HttpClientService, spaces: Spaces);
    /**
     * getAreas - We call this service method to fetch
     * @param areaUrl - The url to get all the areas
     * @return Promise of AreaModel[] - Array of areas
     */
    getAreas(): Observable<AreaModel[]>;
    /**
     * getAreas - We call this service method to fetch
     * @param areaUrl - The url to get all the areas
     * @return Observable of AreaModel[] - Array of areas
     */
    getAreas2(areaUrl: any): Observable<AreaModel[]>;
    getArea(area: any): Observable<AreaModel>;
    getAreaById(areaId: string): Observable<AreaModel>;
    /**
     * checkValidUrl checks if the API url for
     * iterations is valid or not
     * sample url -
     * http://localhost:8080/api/spaces/d7d98b45-415a-4cfc-add2-ec7b7aee7dd5/areas
     *
     * @param URL
     * @return Boolean
     */
    checkValidUrl(url: string): Boolean;
}
