import { EventEmitter } from '@angular/core';
import { CommentUI } from './../../models/comment';
export declare class CommentComponent {
    /**
     * This is the comment input
     */
    comment: CommentUI;
    /**
     * Event to show preview in markdown
     */
    readonly onShowPreview: EventEmitter<{
        rawText: string;
        callBack: (x: string, y: string) => void;
    }>;
    /**
     * This output is emitted when new comment is added
     */
    readonly onCreateRequest: EventEmitter<CommentUI>;
    /**
     * This is an output event for any update request
     * to the comment or it's children
     */
    readonly onUpdateRequest: EventEmitter<CommentUI>;
    private replyActive;
    constructor();
    showPreview(event: {
        rawText: string;
        callBack: (x: string, y: string) => void;
    }): void;
    createComment(event: any): void;
    updateComment(event: any, comment: CommentUI): void;
    updateChildComment(updatedComment: CommentUI): void;
}
